<?php
/*********************/
/*                   */
/*  Dezend for PHP5  */
/*         NWS       */
/*      Nulled.WS    */
/*                   */
/*********************/

function request( $region, $params, $public_key, $private_key )
{
    global $requestoption;
    ini_set( "allow_url_fopen", 1 );
    $method = "GET";
    $host = "ecs.amazonaws.".$region;
    $uri = "/onca/xml";
    $params['Service'] = "AWSECommerceService";
    $params['AWSAccessKeyId'] = $public_key;
    $params['Timestamp'] = gmdate( "Y-m-d\\TH:i:s\\Z" );
    $params['Version'] = "2009-11-01";
    ksort( $params );
    $canonicalized_query = array( );
    foreach ( $params as $param => $value )
    {
        $param = str_replace( "%7E", "~", rawurlencode( $param ) );
        $value = str_replace( "%7E", "~", rawurlencode( $value ) );
        $canonicalized_query[] = $param."=".$value;
    }
    $canonicalized_query = implode( "&", $canonicalized_query );
    $string_to_sign = $method."\n".$host."\n".$uri."\n".$canonicalized_query;
    $signature = base64_encode( hash_hmac( "sha256", $string_to_sign, $private_key, True ) );
    $signature = str_replace( "%7E", "~", rawurlencode( $signature ) );
    $request = "http://".$host.$uri."?".$canonicalized_query."&Signature=".$signature;
    $request = trim( $request );
    while ( $responsetest != TRUE )
    {
        $response = file_get_contents( $request );
        if ( isset( $response ) )
        {
            $responsetest = TRUE;
        }
        else
        {
            $responsetest = FALSE;
            sleep( 1 );
        }
    }
    $pxml = simplexml_load_string( $response );
    if ( $xml === FALSE )
    {
        return false;
    }
    return $pxml;
}

?>
