<?php
/*********************/
/*                   */
/*  Version : 5.1.0  */
/*  Author  : RM     */
/*  Comment : 071223 */
/*                   */
/*********************/

parse_str( getenv( "QUERY_STRING" ) );
define( "ROOT", TRUE );
require_once( dirname( __FILE__ )."/define.inc.php" );
$config = array( "license" => " ", "location" => "hk1", "mode" => "1", "close_msg" => "", "shell_mode" => "1", "shell_url" => "", "template" => "default", "min_port" => "3000", "max_port" => "4000", "cmds" => "script/about, script/process/reaper, script/process/spawner, Restart FCGI Processes||killall -9 dispatch.fcgi", "cmds_arg" => "script/destroy, script/generate, script/performance/benchmarker, script/performance/profiler, script/runner, /usr/local/bin/rake", "generators" => "controller, integration_test, mailer, migration, model, plugin, scaffold, session_migration, web_service", "ssl" => "0", "port" => "2222", "da_admin" => "admin", "hash" => "", "proxy_tpl" => "# Avoid passing requests for specific \"directories/paths\"\nProxyPass /webmail !\nProxyPass /squirrelmail !\nProxyPass /roundcube !\nProxyPass /atmail !\nProxyPass /phpMyAdmin !\nProxyPass /phpmyadmin !\nProxyPass /phpPgAdmin !\nProxyPass /phppgadmin !\n\n# Forward / to the mongrel port\nProxyPass /|app|/ http://localhost:|port|/\n\n# If you want custom status messages in your static,\n# apache-managed content you must give references\n# to your custom pages in a \"static\" directory\nErrorDocument 401 /static/401.shtml\nErrorDocument 404 /static/404.shtml\nErrorDocument 500 /static/500.shtml" );
$md5['L'] = "199b9839c2e2e2225d253542d4904270";
$md5['A'] = "199b9839c2e2e2225d253542d4904270";
$pid['L'] = 6;
$pid['A'] = 5;
$servers = array( "hk1" => "http://daplugin.com/orders/", "us1" => "http://daplugin.net/WSS/" );
$api_server = "http://daplugin.com/adminxx/rpc.php";
$api_key = "259c8aa60138c13e665507a75dea5814";
$is_shell = isset( $is_shell );
if ( !file_exists( $port_file = INCLUDE_PATH."used_ports" ) )
{
    touch( $port_file );
    chmod( $port_file, 438 );
}
$da_user = $_SERVER['USER'];
$timestamp = time( );
if ( !include( LANG_PATH.$_SERVER['LANGUAGE'].".lang.php" ) )
{
    @include( LANG_PATH."/en.lang.php" );
}
require_once( INCLUDE_PATH."global.func.php" );
require_once( CLASS_PATH."Base_wrapper.class.php" );
require_once( CLASS_PATH."Configuration.class.php" );
require_once( CLASS_PATH."License.class.php" );
require_once( CLASS_PATH."PHPAudit_API.class.php" );
require_once( CLASS_PATH."Plugin.class.php" );
require_once( CLASS_PATH."Template.class.php" );
require_once( CLASS_PATH."Wrapper.class.php" );
require_once( CLASS_PATH."RID.class.php" );
require_once( CLASS_PATH."DirectAdmin.class.php" );
( $ignore_config );
$cf = new Configuration( );
( $plugin_id, $plugin_name, PLUGIN_PATH, $plugin_item, $logs );
$plugin = new $plugin_class( );
( $plugin_id, $plugin_name, PLUGIN_PATH, $plugin_item );
$wrapper = new Wrapper( );
$config = array_merge( $config, get_config( $wrapper ) );
( $config['template'], TPL_PATH, TPL_CACHE_PATH );
$tpl = new Template( );
$prefix = 0 < strlen( trim( $config['license'] ) ) ? $config['license'][0] : "A";
( $pid[$prefix], $md5[$prefix], $config['license'], $servers, $config['location'] );
$lic = new License( );
( $api_server, $api_key );
$api = new PHPAudit_API( );
if ( $is_shell )
{
    ( "127.0.0.1", $config['port'], $config['ssl'] );
    $da = new DirectAdmin( );
}
else
{
    ( "127.0.0.1", $_SERVER['SERVER_PORT'], $_SERVER['SSL'] );
    $da = new DirectAdmin( );
}
$admin_level = $plugin->chk_path( "admin" );
$ver_info = $plugin->version_info( $lang['ver_info'], $admin_level );
$hostname = hostname( );
if ( 0 < strlen( trim( $config['license'] ) ) )
{
    $license = $api->get_license_info( $config['license'] );
    if ( !file_exists( INCLUDE_PATH."key.php" ) || $license['local_expires'] <= $timestamp )
    {
        file_put_contents( CACHE_PATH."key.php", $api->get_local_key( $config['license'] ) );
        $wrapper->save_local_key( );
    }
}
$config['cmds'] = array_map( "trim", explode( ",", $config['cmds'] ) );
$config['cmds_arg'] = array_map( "trim", explode( ",", $config['cmds_arg'] ) );
$config['generators'] = array_map( "trim", explode( ",", $config['generators'] ) );
sort( $config['cmds'] );
sort( $config['cmds_arg'] );
sort( $config['generators'] );
if ( isset( $show_ver ) )
{
    $gems = $plugin->version( "gems" );
    $rid_ver = $plugin->version( );
    $ruby_ver = $plugin->version( "ruby" );
    $rails_ver = $plugin->version( "rails" );
    $gem_ver = $plugin->version( "gem" );
    $mongrel_ver = $plugin->version( "mongrel" );
    include( $tpl->output( "show_ver" ) );
    exit( 0 );
}
if ( $admin_level )
{
    $menu = "<table align=\"center\" border=\"0\" cellspacing=\"1\" cellpadding=\"3\">\n<tr>\n<td>&bull; <a href=\"/CMD_PLUGINS_ADMIN/{$plugin_id}/index.html#1\">{$lang['lic_details']}</a></td>\n<td>&bull; <a href=\"/CMD_PLUGINS_ADMIN/{$plugin_id}/index.html#2\">{$lang['settings']}</a></td>\n<td>&bull; <a href=\"/CMD_PLUGINS_ADMIN/{$plugin_id}/logs.html\">{$lang['view_log']}</a></td>\n<td>&bull; <a href=\"http://daplugin.com/orders/client_area.php\">{$lang['client_area']}</a></td>\n</tr>\n</table>";
}
else
{
    unset( $api );
    unset( $license );
    $lic->validate( );
    $wrapper->user_config( $da_user );
    $domain = isset( $domain ) ? $domain : "";
    if ( !$plugin->chk_domain( $da_user, $domain ) )
    {
        alert( $domain, "request_error", "do_not_own_domain" );
    }
    if ( $da_user != "admin" )
    {
        if ( !$config['mode'] )
        {
            alert( $domain, "disabled_title", $config['close_msg'] );
        }
        if ( !$plugin->is_allowed( $da_user ) )
        {
            alert( $domain, "request_error", "not_allowed" );
        }
    }
    if ( !$cf->chk_config( $config ) )
    {
        alert( $domain, "request_error", "config_not_set" );
    }
    if ( !is_dir( $rails_dir = "/home/".$da_user."/domains/".$domain."/Rails/" ) )
    {
        @mkdir( $rails_dir );
    }
    require_once( CLASS_PATH."Mongrel.class.php" );
    require_once( CLASS_PATH."Rails.class.php" );
    ( $rails_dir );
    $rails = new Rails( );
    ( $port_file, $config['min_port'], $config['max_port'] );
    $mongrel = new Mongrel( );
}
$wrapper->clean_cache( );
unset( $servers );
unset( $md5 );
unset( $pid );
unset( $api_server );
unset( $api_key );
unset( $prefix );
unset( $plugin_class );
?>
