<?php
/*********************/
/*                   */
/*  Version : 5.1.0  */
/*  Author  : RM     */
/*  Comment : 071223 */
/*                   */
/*********************/

class nm_serial
{

    public $chave_completa = NULL;
    public $tipo_chave = NULL;
    public $dv_1 = NULL;
    public $dv_2 = NULL;
    public $dv_3 = NULL;
    public $dv_4 = NULL;
    public $seq_serial = array( );
    public $alfa = array
    (
        1 => "1",
        2 => "2",
        3 => "3",
        4 => "4",
        5 => "5",
        6 => "6",
        7 => "7",
        8 => "8",
        9 => "9",
        "A" => "10",
        "B" => "11",
        "C" => "12",
        "D" => "13",
        "E" => "14",
        "F" => "15",
        "G" => "16",
        "H" => "17",
        "I" => "18",
        "J" => "19",
        "K" => "20",
        "L" => "21",
        "M" => "22",
        "N" => "23",
        "O" => "24",
        "P" => "25",
        "Q" => "26",
        "R" => "27",
        "S" => "28",
        "T" => "29",
        "U" => "30",
        "V" => "31",
        "W" => "32",
        "X" => "33",
        "Y" => "34",
        "Z" => "35"
    );
    public $num = array
    (
        1 => "1",
        2 => "2",
        3 => "3",
        4 => "4",
        5 => "5",
        6 => "6",
        7 => "7",
        8 => "8",
        9 => "9",
        10 => "A",
        11 => "B",
        12 => "C",
        13 => "D",
        14 => "E",
        15 => "F",
        16 => "G",
        17 => "H",
        18 => "I",
        19 => "J",
        20 => "K",
        21 => "L",
        22 => "M",
        23 => "N",
        24 => "O",
        25 => "P",
        26 => "Q",
        27 => "R",
        28 => "S",
        29 => "T",
        30 => "U",
        31 => "V",
        32 => "W",
        33 => "X",
        34 => "Y",
        35 => "Z"
    );

    public function nm_avanca_serial( $seq )
    {
        $this->abre_serial( $seq );
        ++$this->seq_serial[11];
        $x = 11;
        for ( ; 0 < $x; --$x )
        {
            if ( !( $this->seq_serial[$x] == 36 ) )
            {
                break;
            }
            $this->seq_serial[$x] = 1;
            ++$this->seq_serial[$x - 1];
        }
        $retorno = $this->num[$this->seq_serial[1]].$this->num[$this->seq_serial[2]].$this->num[$this->seq_serial[3]].$this->num[$this->seq_serial[4]].$this->num[$this->seq_serial[5]].$this->num[$this->seq_serial[6]].$this->num[$this->seq_serial[7]].$this->num[$this->seq_serial[8]].$this->num[$this->seq_serial[9]].$this->num[$this->seq_serial[10]].$this->num[$this->seq_serial[11]];
        return $retorno;
    }

    public function nm_gera_serial( $tp_ch, $ult_seq )
    {
        $this->tipo_chave = $this->alfa[$tp_ch];
        $this->abre_serial( $ult_seq );
        $this->calc_dv( );
        $this->fecha_chave( );
        return $this->chave_completa;
    }

    public function nm_valida_serial( $serial )
    {
        $this->chave_completa = $serial.str_repeat( "X", 16 - strlen( $serial ) );
        $this->abre_chave( );
        $this->calc_dv( );
        if ( substr( $this->chave_completa, 4, 1 ) == $this->num[$this->dv_1] && substr( $this->chave_completa, 8, 1 ) == $this->num[$this->dv_2] && substr( $this->chave_completa, 12, 1 ) == $this->num[$this->dv_3] && substr( $this->chave_completa, 0, 1 ) == $this->num[$this->dv_4] )
        {
            return TRUE;
        }
        return FALSE;
    }

    public function abre_serial( $seq )
    {
        $seq = strtoupper( $seq );
        if ( strlen( $seq ) < 11 )
        {
            $seq = str_repeat( "1", 11 - strlen( $seq ) ).$seq;
        }
        $this->seq_serial[1] = $this->alfa[substr( $seq, 0, 1 )];
        $this->seq_serial[2] = $this->alfa[substr( $seq, 1, 1 )];
        $this->seq_serial[3] = $this->alfa[substr( $seq, 2, 1 )];
        $this->seq_serial[4] = $this->alfa[substr( $seq, 3, 1 )];
        $this->seq_serial[5] = $this->alfa[substr( $seq, 4, 1 )];
        $this->seq_serial[6] = $this->alfa[substr( $seq, 5, 1 )];
        $this->seq_serial[7] = $this->alfa[substr( $seq, 6, 1 )];
        $this->seq_serial[8] = $this->alfa[substr( $seq, 7, 1 )];
        $this->seq_serial[9] = $this->alfa[substr( $seq, 8, 1 )];
        $this->seq_serial[10] = $this->alfa[substr( $seq, 9, 1 )];
        $this->seq_serial[11] = $this->alfa[substr( $seq, 10, 1 )];
    }

    public function abre_chave( )
    {
        $this->dv_4 = $this->alfa[substr( $this->chave_completa, 0, 1 )];
        $this->tipo_chave = $this->alfa[substr( $this->chave_completa, 1, 1 )];
        $this->seq_serial[1] = $this->alfa[substr( $this->chave_completa, 2, 1 )];
        $this->seq_serial[2] = $this->alfa[substr( $this->chave_completa, 3, 1 )];
        $this->dv_1 = $this->alfa[substr( $this->chave_completa, 4, 1 )];
        $this->seq_serial[3] = $this->alfa[substr( $this->chave_completa, 5, 1 )];
        $this->seq_serial[4] = $this->alfa[substr( $this->chave_completa, 6, 1 )];
        $this->seq_serial[5] = $this->alfa[substr( $this->chave_completa, 7, 1 )];
        $this->dv_2 = $this->alfa[substr( $this->chave_completa, 8, 1 )];
        $this->seq_serial[6] = $this->alfa[substr( $this->chave_completa, 9, 1 )];
        $this->seq_serial[7] = $this->alfa[substr( $this->chave_completa, 10, 1 )];
        $this->seq_serial[8] = $this->alfa[substr( $this->chave_completa, 11, 1 )];
        $this->dv_3 = $this->alfa[substr( $this->chave_completa, 12, 1 )];
        $this->seq_serial[9] = $this->alfa[substr( $this->chave_completa, 13, 1 )];
        $this->seq_serial[10] = $this->alfa[substr( $this->chave_completa, 14, 1 )];
        $this->seq_serial[11] = $this->alfa[substr( $this->chave_completa, 15, 1 )];
    }

    public function fecha_chave( )
    {
        $this->chave_completa = $this->num[$this->dv_4].$this->num[$this->tipo_chave].$this->num[$this->seq_serial[1]].$this->num[$this->seq_serial[2]].$this->num[$this->dv_1].$this->num[$this->seq_serial[3]].$this->num[$this->seq_serial[4]].$this->num[$this->seq_serial[5]].$this->num[$this->dv_2].$this->num[$this->seq_serial[6]].$this->num[$this->seq_serial[7]].$this->num[$this->seq_serial[8]].$this->num[$this->dv_3].$this->num[$this->seq_serial[9]].$this->num[$this->seq_serial[10]].$this->num[$this->seq_serial[11]];
    }

    public function calc_dv( )
    {
        $soma = 0;
        $soma += $this->seq_serial[9] * 4;
        $soma += $this->seq_serial[10] * 3;
        $soma += $this->seq_serial[11] * 2;
        $this->dv_3 = $soma % 36;
        if ( $this->dv_3 < 10 )
        {
            $this->dv_3 += 11;
        }
        $soma += $this->dv_3 * 5;
        $soma += $this->seq_serial[6] * 8;
        $soma += $this->seq_serial[7] * 7;
        $soma += $this->seq_serial[8] * 6;
        $this->dv_2 = $soma % 36;
        if ( $this->dv_2 < 10 )
        {
            $this->dv_2 += 11;
        }
        $soma += $this->dv_2 * 9;
        $soma += $this->seq_serial[3] * 13;
        $soma += $this->seq_serial[4] * 12;
        $soma += $this->seq_serial[5] * 11;
        $this->dv_1 = $soma % 36;
        if ( $this->dv_1 < 10 )
        {
            $this->dv_1 += 11;
        }
        $soma += $this->dv_1 * 14;
        $soma += $this->tipo_chave * 17;
        $soma += $this->seq_serial[1] * 16;
        $soma += $this->seq_serial[2] * 15;
        $this->dv_4 = $soma % 36;
        if ( $this->dv_4 < 10 )
        {
            $this->dv_4 += 11;
        }
    }

}

?>
